﻿//------------------------------------------------------------------------------
// 2014.04.02 by 龟山阿卍 QQ 1467948783                                        -
// http://www.cnblogs.com/onechen/                                             -
//                                                                             -
// 需修改                                                                      -
// FMX.VirtualKeyboard.Android.pas                                             -
//------------------------------------------------------------------------------

unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,

  FMX.Platform,
  FMX.VirtualKeyboard.Android,
  FMX.VirtualKeyboard,

  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Edit,
  FMX.StdCtrls, FMX.Layouts, FMX.Memo;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    Label1: TLabel;
    VirtualKeyboardTimer: TTimer;
    Memo1: TMemo;
    Edit1: TEdit;
    procedure FormVirtualKeyboardHidden(Sender: TObject;
      KeyboardVisible: Boolean; const Bounds: TRect);
    procedure FormVirtualKeyboardShown(Sender: TObject;
      KeyboardVisible: Boolean; const Bounds: TRect);
    procedure VirtualKeyboardTimerTimer(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
  private
    { private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

// 显示键盘
function ShowVirtualKeyboard(const AControl: TFmxObject): Boolean;
var Service1: IFMXVirtualKeyboardService;
begin
     if (ObtainKeyboardRect.Height < 30) and
        TPlatformServices.Current.SupportsPlatformService(IFMXVirtualKeyboardService, IInterface(Service1)) then
          Result := Service1.ShowVirtualKeyboard(AControl)
     else Result := False;
end;

procedure TForm1.FormVirtualKeyboardHidden(Sender: TObject;
  KeyboardVisible: Boolean; const Bounds: TRect);
begin
     Edit1.Text := 'Keyboard hidden!';
     Memo1.Text := Format('W: %d H: %d', [Bounds.Width, Bounds.Height]);

     VirtualKeyboardTimer.Enabled := False; // 关闭检查键盘高度
end;

procedure TForm1.FormVirtualKeyboardShown(Sender: TObject;
  KeyboardVisible: Boolean; const Bounds: TRect);
begin
     Edit1.Text := 'Keyboard shown!';
     Memo1.Text := Format('W: %d H: %d', [Bounds.Width, Bounds.Height]);

     VirtualKeyboardTimer.Enabled := True; // 开启检查键盘高度
end;

procedure TForm1.VirtualKeyboardTimerTimer(Sender: TObject);
var R: TRect;
begin
     // 检查键盘高度 < 30 代表键盘关闭.
     R := ObtainKeyboardRect;
     if R.Height < 30 then
        Self.OnVirtualKeyboardHidden(Sender, False, R);
end;

procedure TForm1.Edit1Click(Sender: TObject);
begin
     // 在 TEdit 或 TMemo 需要用到键盘的控件, 加入下行, 才能确保关闭键盘后, 再点一次可以显示键盘.
     ShowVirtualKeyboard(TFmxObject(Sender));
end;

end.